C PROGRAMA RSECDERIV.F
C TABARE GALLARDO - OCTUBRE 2020 - SOLYMAR
C CALCULA FPERTURBADORA SECULAR INTEGRANDO NUMERICAMENTE LAMBDA1 Y LAMBDA2
C LA PARTE INDIRECTA ES NULA
C TAMBIEN CALCULA LAS DERIVADAS PARCIALES DE RSEC
C EN CASO DE INTERSECCION DE ORBITAS SE RECOMIENDA AUMENTAR PASOS
      IMPLICIT REAL*8 (A-H,J-Z)
      dimension x(20,500),y(20,500),z(20,500)
      DIMENSION APLA(20),EPLA(20),JPLA(20),LPLA(20),PPLA(20),MASA(20)
      DIMENSION Rsec(5,20),DRDE(20),DRDI(20),DRDP(20),DRDO(20)
      CHARACTER*50 APESOS
      TWOPI = 8.0D0*DATAN(1.0D0)
      CERO  = 0.0D0
      UNO   = 1.0D0
      KDANBY=0.85D0
      PI=TWOPI/2.D0
      G2R=PI/180.D0
      ERROR=1.D-12
      gau=0.01720209895d0
      GA2=GAU**2


C DELTA PARA CALCULO DE DERIVADAS, UNA mileESIMA DEL INTERVALO APROX
      deltaex=0.0001d0
C EN RADIANES
      deltaan=0.0006d0

       OPEN(1,FILE="Rsecderiv.ent",STATUS="OLD")
C MASA ESTELAR
      READ(1,1004)APESOS
      READ(1,*) MST
C DATOS CUERPO INTERIOR (1) Y EXTERIOR (2)
C a,e,i,LONG NODO, LONG PERI
      READ(1,1004)APESOS
      READ(1,*) APLA(1),EPLA(1),J1G,L1G,P1G
      JPLA(1)=J1G*G2R
      LPLA(1)=L1G*G2R
      PPLA(1)=P1G*G2R
C PARA CALCULO DE DERIVADAS
      APLA(2)=APLA(1)
      EPLA(2)=EPLA(1)+deltaex
      JPLA(2)=JPLA(1)
      LPLA(2)=LPLA(1)
      PPLA(2)=PPLA(1)

      APLA(3)=APLA(1)
      EPLA(3)=EPLA(1)
      JPLA(3)=JPLA(1)+deltaan/2.d0
      LPLA(3)=LPLA(1)
      PPLA(3)=PPLA(1)

      APLA(4)=APLA(1)
      EPLA(4)=EPLA(1)
      JPLA(4)=JPLA(1)
      LPLA(4)=LPLA(1)+deltaan
      PPLA(4)=PPLA(1)

      APLA(5)=APLA(1)
      EPLA(5)=EPLA(1)
      JPLA(5)=JPLA(1)
      LPLA(5)=LPLA(1)
      PPLA(5)=PPLA(1)+deltaan

      
      
      
      
      
      READ(1,1004)APESOS
      READ(1,*) INPLA
      READ(1,1004)APESOS
      do i=6,inpla+5
      READ(1,*) APLA(i),EPLA(i),J2G,L2G,P2G,MASA(I)
      JPLA(i)=J2G*G2R
      LPLA(i)=L2G*G2R
      PPLA(i)=P2G*G2R
      ENDDO
C NUMERO DE PASOS EN LA INTEGRACION
C      READ(1,1004)APESOS
C      READ(1,*) IPASOS
      CLOSE(1)

      IPASOS=400
      
      
      
C PARA CADA OBJETO
      do iob=1,inpla+5


        E1=Epla(IOB)
        A1=apla(IOB)
        J1=Jpla(IOB)
        L1=Lpla(IOB)
        P1=Ppla(IOB)

C CALCULO 3 VECTORES XYZ
      DO ILAMBDA1=1,IPASOS
        LA1=DFLOAT(ILAMBDA1)/DFLOAT(IPASOS)*TWOPI
C ANOMEDIA
        AM1=LA1-P1
 200    IF (AM1.GT.TWOPI) THEN
          AM1=AM1-TWOPI
          GOTO 200
        END IF
 201    IF (AM1.LT.CERO) THEN
          AM1=AM1+TWOPI
          GOTO 201
        END IF

C KEPLER SEGUN DANBY  CUERPO 1
      AEX=AM1+DSIGN(UNO,DSIN(AM1))*KDANBY*E1

 210     AEXN=AM1+E1*DSIN(AEX)
      IF(DABS(AEXN-AEX).GT.ERROR) THEN
        AEX=AEXN
        GOTO 210
      ENDIF
      AEX1=AEXN
      
C ANOM VERDADERA
      AVE1=DACOS((DCOS(AEX1)-E1)/(UNO-E1*DCOS(AEX1)))
      IF(AM1.GT.PI) AVE1=TWOPI-AVE1
C DIST HELIOC
      R1=A1*(UNO-E1*DCOS(AEX1))
      
C XYZ
      X1=R1*(DCOS(L1)*DCOS(P1-L1+AVE1)-DSIN(L1)*DSIN(P1-L1+AVE1)
     **DCOS(J1))
      Y1=R1*(DSIN(L1)*DCOS(P1-L1+AVE1)+DCOS(L1)*DSIN(P1-L1+AVE1)
     **DCOS(J1))
      Z1=R1*DSIN(P1-L1+AVE1)*DSIN(J1)
      X(IOB,ILAMBDA1)=X1
      Y(IOB,ILAMBDA1)=Y1
      Z(IOB,ILAMBDA1)=Z1

      ENDDO
      ENDDO
      
C AHORA CALCULO LA INTEGRAL DEL ASTEROIDE Y SUS SOMBRAS CON CADA PLANETA POR SEPARADO

        DO IPLA=6,Inpla+5
          DO IA=1,5
        rsec(IA,ipla)=cero
          ENDDO
        enddo



      DO IP1=1,IPASOS
      
        DO 345 IA=1,5
      
      
        X1=X(IA,IP1)
        Y1=Y(IA,IP1)
        Z1=Z(IA,IP1)

        DO IPLA=6,Inpla+5

        rdirtot=cero

        DO IP2=1,IPASOS
        X2=X(IPLA,IP2)
        Y2=Y(IPLA,IP2)
        Z2=Z(IPLA,IP2)

C DELTA
        DELTA=DSQRT((X1-X2)**2+(Y1-Y2)**2+(Z1-Z2)**2)

        RDIR=UNO/DELTA

        RDIRTOT=RDIRTOT+RDIR
        ENDDO
        rsec(IA,ipla)=rsec(IA,ipla)+rdirtot
      ENDDO
      
  345 CONTINUE
      enddo

        do ia=1,5
        DO IPLA=6,Inpla+5
        rsec(ia,ipla)=rsec(ia,ipla)*GA2*masa(ipla)/DFLOAT(IPASOS)**2
        enddo
        enddo



      drdet=cero
      drdit=cero
      drdot=cero
      drdpt=cero

      do ipla=6,inpla+5
      drde(ipla)=(rsec(2,ipla)-rsec(1,ipla))/deltaex
      drdi(ipla)=(rsec(3,ipla)-rsec(1,ipla))/(deltaan/2.d0)
      drdo(ipla)=(rsec(4,ipla)-rsec(1,ipla))/deltaan
      drdp(ipla)=(rsec(5,ipla)-rsec(1,ipla))/deltaan
      drdet=drdet+drde(ipla)
      drdit=drdit+drdi(ipla)
      drdot=drdot+drdo(ipla)
      drdpt=drdpt+drdp(ipla)
      enddo
      
C calculo derivadas de elementos

      E=EPLA(1)
      na2=GAU*dsqrt(MST*APLA(1))
      SQE=DSQRT(UNO-E**2)
      YN=JPLA(1)
C VARIACION POR SIGLO
      DEDT=-SQE/NA2/E*DRDPT*36525.D0
C GRADOS POR SIGLO
      DIDT=-(DRDPT*DTAN(YN/2.D0)+DRDOT/DSIN(YN))/SQE/NA2*36525.D0/G2R
C GRADOS POR SIGLO
      DODT=DRDIT/DSIN(YN)/SQE/NA2*36525.D0/G2R
C GRADOS POR SIGLO
      DPDT=(SQE/NA2/E*DRDET+DRDIT*DTAN(YN/2.d0)/SQE/NA2)*36525.D0/G2R





      OPEN(1,FILE="Rsecderiv.sal",STATUS="UNKNOWN",ACCESS="APPEND")
       WRITE(1,*)"Rsec y derivadas parciales generadas por cada planeta"
        WRITE(1,111) "Rsec  ",(rsec(1,i),I=6,INPLA+5)
        WRITE(1,111) "dR/de  ",(DRDE(i),I=6,INPLA+5)
        WRITE(1,111) "dR/di  ",(DRDI(i),I=6,INPLA+5)
        WRITE(1,111) "dR/dN  ",(DRDO(i),I=6,INPLA+5)
        WRITE(1,111) "dR/dP  ",(DRDP(i),I=6,INPLA+5)
        WRITE(1,112) "d(eiNP)/dt total =  ",DEDT,DIDT,DODT,DPDT
       WRITE(1,*) "(derivadas de angulos en grados por siglo)"
       WRITE(1,*) "  "

      CLOSE(1)

 1004  FORMAT(A76)
  111 FORMAT(A20,8E15.6)
  112 FORMAT(A20,4E15.6)

      STOP
      END
      
      
      
      
